// AMIRE GYELNI KELL: MACRO HIBNL A BACKSLASH UTN VALAHOL SPACE VAN!

#include "SettingsForm.h"
#include <string.h>
#include <math.h>

#pragma warning (disable:4800)


using namespace FilterSpace;
using namespace System::Windows::Forms;

//////////////////////////////////
// FILTER-CORE-MACRO  <-- BEGIN //
//////////////////////////////////

#define FCORE(XPARAM, YPARAM) \
{ \
	int z = sx + x;	\
	int r = radius, r1 = radius + 1, r21 = radius * 2 + 1, r12 = (radius + 1) * (radius + 1); \
	bool apply = !mask;	\
	if (mask) apply = mask[z >> 3] & ((z & 0x07) ? (1 << (z & 0x07)) : 1); \
	\
	if (apply) \
	{ \
		for (int ch = 0; ch < channels; ++ch) \
		{ \
			int kernel_buffer_index = 0; \
			int x_in = x + x_pre; \
			minvar = 0x0fffffff; \
			\
			for (int my = -r; my <= r; my++) \
			{ \
				byte* line = virtual_image[ (YPARAM) ]; \
				int   from = MAX(x_in - r, 0);	\
				int   to   = MIN(x_in + r, x_caching - 1);	\
				for (int mx = 0; mx <= r * 2; ++mx) kernel_buffer[kernel_buffer_index++] = line[ (XPARAM) * channels + ch ]; \
			} \
			for (int i = 0; i < 4; i++) \
			{ \
				kb = kernel_buffer + mini_block_pos[i]; \
				mean = 0; \
				for (miniy = 0; miniy < r1; miniy++, kb += r21) \
					for (minix = 0; minix < r1; minix++) mean += kb[minix]; \
				mean  = mean / r12; \
				varc  = 0; \
				kb    = kernel_buffer + mini_block_pos[i]; \
				\
				for (miniy = 0; miniy < r1; miniy++, kb += r21) \
				{ \
					for (minix = 0; minix < r1; minix++) \
					{ \
						d     = mean - kb[minix]; \
						varc += d * d; \
					} \
				} \
				if (varc < minvar) \
				{ \
					minvar = varc; \
					value  = mean; \
				} \
			} \
			*dout++ = value; \
		} \
	} \
	else \
	{ \
		for (int ch = 0; ch < channels; ++ch) *dout++ = virtual_image[y_in][(x + sx) * channels + ch]; \
	} \
}
////////////////////////////////
// FILTER-CORE-MACRO  <-- END //
////////////////////////////////


///////////////////////
//       FILTER      //
///////////////////////

bool FilterCore(filtersettings* f, int sx, int sy, int sw, int sh, Semaphore^ updater)
{
	if      (!f)           return false;
	else if (!(f->datain)) return false;

	int radius     = f->nCoreExecutionSize;
	int radius21   = 2 * radius + 1;
	int submatsize = (radius + 1) * (radius + 1);

	int mini_block_pos[4] = { 0, 0, 0, 0 };
	mini_block_pos[1] = f->nCoreExecutionSize;
	mini_block_pos[2] = (2 * mini_block_pos[1] + 1) * mini_block_pos[1];
	mini_block_pos[3] = mini_block_pos[1] + mini_block_pos[2];

	// BEGIN --> COMMON SUPPORT CODE (DO NOT MODIFY!)

	// ImageFilterAccelerator RANGECHECKS sx, sy, sw, sh AND SET THEM CORRECTLY
	// IF YOU DO NOT USE ImageFilterAccelerator, YOU HAVE TO DO IT HERE MANUALLY 
	ImageFilterAccelerator* img = new ImageFilterAccelerator(f, sx, sy, sw, sh, radius);
	byte** virtual_image = img->GetVirtualImage();

	int radius2 = radius * 2;
	int x_pre  = img->GetPreX();
	int x_post = img->GetPostX();
	int y_pre  = img->GetPreY();
	int y_post = img->GetPostY();	
	int x_caching = sw + x_pre + x_post;
	int y_caching = sh + y_pre + y_post;

	int sout = f->strideout;
	int mstride = (f->width + 7) >> 3;
	int channels = f->channelcountin;
	byte *mask = f->mask;
	byte *dout = 0;

	// END --> COMMON SUPPORT CODE (DO NOT MODIFY!)

	int width = f->width;
	int height = f->height;
	int x, y;

	// MACRO VARIABLES
	int *kb, d, varc, value, minvar, mean, minix, miniy;
	int *kernel_buffer = new int[radius21 * radius21];

	for (y = 0; y < sh; y++)
	{
		int y_in  = y + y_pre;
		dout = f->dataout + sout * y;

		img->StepImageScanLine();

		if (y < radius - y_pre || y >= sh + y_post - radius) // TOP AND BOTTOM "INCOMPLETE" ROWS
		{
			for (x = 0; x < sw; x++) FCORE(INTERVAL_LIMITER(from + mx, 0, x_caching - 1), INTERVAL_LIMITER(y_in + my, 0, y_caching - 1))
		}
		else
		{
			// LEFT "INCOMPLETE" COLUMNS
			for (x = 0; x < radius - x_pre; x++)					FCORE(INTERVAL_LIMITER(from + mx, 0, x_caching - 1), y_in + my)

			// COMPLETE CENTER REGION
			for (x = radius - x_pre; x < sw + x_post - radius; x++) FCORE(from + mx, y_in + my)

			// RIGHT "INCOMPLETE" COLUMNS
			for (x = sw + x_post - radius; x < sw; x++)				FCORE(INTERVAL_LIMITER(from + mx, 0, x_caching - 1), y_in + my)
		}

		ImageFilterBase::UpdateFilterStatus(f, sw, updater); // FOR PERFORMANCE MEASUREMENT
		if (f->nCoreKillSignal) { if (*(f->nCoreKillSignal)) break; }
	}

	delete img;
	delete [] kernel_buffer;

	// FILTER CODE END -->

	return true;
}




IntPtr ImageFilter::CreateFilterSettings(Byte* fs, bool silent)
{
	int indata = 0, outdata = 0, stride = 0, height = 0, run_local = 1;

	bool cancelled = false;

	if (!fs) return IntPtr(0);

	xml_node^ xn = gcnew xml_node( fs );

	filtersettings* f = XmlToMyStruct( xn, true );

	// GET "Run_Local" PARAMETER
	xn->XmlGetChildValueByName("Run_Local", run_local);

	// CLONE "InputImage0" TO "OutputImage0"
	xml_node^ xt = nullptr;

	if (f && !silent)
	{
		FilterTemplate::SettingsForm^ form = gcnew FilterTemplate::SettingsForm(f);
		form->ShowDialog();
		cancelled = form->FilterCancelled;
		delete form;
	}
	if (cancelled)
	{
		delete f;
		delete xn;
		return IntPtr(0);
	} 

	if (xn->XmlGetChildByName(xt, "InputImage0" )) xt->XmlGetChildValueByName("Data", indata);
	if (xn->XmlGetChildByName(xt, "OutputImage0")) xt->XmlGetChildValueByName("Data", outdata);

	xn->XmlRemoveChildByName("OutputImage0");
	xn->XmlGetChildByName(xt, "InputImage0");

	Byte* fb = xt->XML_Tree_Marshal();
	xt = gcnew xml_node(fb);
	delete [] fb;
	xt->name = "OutputImage0";

	// SET "Run_Local" settings
	if (!run_local)
	{
		if (outdata == 0 || indata == outdata)  // FIRST RUN OF CreateFilterSettings
		{
			stride = f->stridein;
			height = f->height;
			if (stride * height == 0) return IntPtr(0);
			//MessageBox::Show("Allocating: " + (stride * height).ToString() + " bytes.");
			xt->XmlSetChildValueByName("Data", ((int)(void*)(new Byte[stride * height])));
		}
		else
		{
			xt->XmlSetChildValueByName("Data", outdata);
		}
	}
	xn->children.Add( xt );


	xn->XmlSetChildValueByName("nCore!ExecutionSize", f->nCoreExecutionSize, false); // RADIUS == 1 ALWAYS FOR THIS FILTER

	delete f;
	Byte* res = xn->XML_Tree_Marshal();
	delete xn;
	return (IntPtr)(void*)res;
}


filtersettings* ImageFilter::XmlToMyStruct(xml_node^ xn, bool creating)
{
	xml_node^ xntmp;

	if (! xn->XmlGetChildByName(xntmp, "InputImage0")) return 0;
	filtersettings* filset = new filtersettings;
	int packed, interleaved;
	if (GetOneImageSetting(xntmp, filset->width, filset->height, filset->stridein, packed, interleaved, filset->channelcountin, filset->pixelsizein, filset->datain)) 
	{
		MessageBox::Show("XmlToMyStruct - 0 - " + creating.ToString());
		delete filset;
		return 0;
	}

	if (! xn->XmlGetChildByName(xntmp, "OutputImage0") && !creating)
	{
		MessageBox::Show("XmlToMyStruct - 1 - " + creating.ToString());
		delete filset;
		return 0;
	}

	if (GetOneImageSetting(xntmp, filset->width, filset->height, filset->strideout, packed, interleaved, filset->channelcountout, filset->pixelsizeout, filset->dataout))
	{
		MessageBox::Show("XmlToMyStruct - 2 - " + creating.ToString());
		delete filset;
		return 0;
	}

	int m = 0;
	if ( xn->XmlGetChildByName(xntmp, "Mask") )	xntmp->XmlGetChildValueByName("Data", m);
	filset->mask = (Byte*)(void*)m;

	filset->processing_size    = ( xn->XmlGetChildValueByName("Processing_Size", m) )  ? (int*)(void*)m : 0;
	filset->processing_ptr     = ( xn->XmlGetChildValueByName("Processing_Ptr", m) )   ? (int*)(void*)m : 0;
	filset->nCoreEnabled       = ( xn->XmlGetChildValueByName("nCore!Enabled", m) )    ? m : 0;
	filset->nCoreKillSignal    = ( xn->XmlGetChildValueByName("nCore!KillSignal", m) ) ? (int*)(void*)m : 0;
	filset->nCoreExecutionSize = ( xn->XmlGetChildValueByName("nCore!ExecutionSize", m) ) ? m : 1;

	return filset;
}

bool ImageFilter::CanLocalize(){ return true; }


IntPtr ImageFilter::GetSupportedFormats()
{
	xml_node ^xn, ^node = gcnew xml_node( nullptr, "", "", "" );

	node->children.Add( gcnew xml_node(node, "InputImageCount", "", "1" ) );
	node->children.Add( gcnew xml_node(node, "OutputImageCount", "", "1" ) );
	xn = gcnew xml_node( node, "InputImage0", "", "" );
	node->children.Add( xn );
	//                     PinName, width, height, stride, packed, interleaved, channelcount, pixelsize, data)
	CreateImageSetting(xn, "Input",     0,      0,      0,      1,           1,            0,         0,    0);
	xn->XmlGetChildByName( xn, "ChannelsBitAllocation" );
	SetChannelsBitAllocation(xn, 0, 8);

	xn = gcnew xml_node( node, "OutputImage0", "", "" );
	node->children.Add( xn );
	//                     PinName, width, height, stride, packed, interleaved, channelcount, pixelsize, data)
	CreateImageSetting(xn, "Output",     0,      0,      0,      1,           1,            0,         0,    0);
	xn->XmlGetChildByName( xn, "ChannelsBitAllocation" );
	SetChannelsBitAllocation(xn, 0, 8);
	/*
	width,height = 2 --> width, height must be power of 2... = 8 --> multiply of 8
	packed, interleaved = 0, 1 (true, false)
	channelcount = 0 --> any positive number
	channelcount > 0 --> the value itself
	*/

	return (IntPtr)(void*)node->XML_Tree_Marshal();
}



// ***********************************************************************************************
// DO NOT MODIFY OR MOVE TO ELSEWHERE THESE HELPER FUNCTIONS
// THESE ARE HERE BECAUSE OF FilterCore IMPLEMENTED IN THIS FILE!!!

bool ImageFilter::FilterCore(filtersettings* f, int sx, int sy, int sw, int sh)
{
	return (::FilterCore(f, sx, sy, sw, sh, nullptr));
}

bool ImageFilter::ExecuteFilter(Byte* fs)
{ 
	bool b = false;
	if (!fs ) return false;
	xml_node^ xn = gcnew xml_node( fs );
	filtersettings* filset = XmlToMyStruct( xn, false );
	delete xn;
	if (filset)
	{
		*(filset->processing_ptr)  = 0;
		*(filset->processing_size) = filset->width * filset->height;
		int  cpucores              = System::Environment::ProcessorCount;
		bool parallelized          = filset->nCoreEnabled && (cpucores > 1); 
		filter_core_func f         = (::FilterCore);

		//MessageBox::Show(filset->nCoreExecutionSize.ToString());

		b = (parallelized) ? ImageFilterBase::ExecuteFilterBox(filset, f) : f(filset, 0, 0, 0, 0, nullptr); 


		delete filset;
		*(filset->processing_ptr) = *(filset->processing_size);
		*(filset->nCoreKillSignal) = 0; // RESET SIGNAL BIT IN THE MAIN PROGRAM
	}
	return b;
}
